=== debian/changelog ===
cryptominisat (5.8.0+dfsg1-2) unstable; urgency=medium

  * Try to make the build reproducible (Closes: #1003993).
  * Bump standards-version to 4.6.0.
  * Document reproducible-build.patch as Debian-specific.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 22 Feb 2022 14:17:45 +0100

cryptominisat (5.8.0+dfsg1-1) unstable; urgency=medium

  * Add patch for reproducible builds. (Closes: #960388)
  * New upstream release.
  * Bump dh-compat to 13.
  * Update d/copyright.
  * Add patch fixing typos.
  * Add patch fixing manpages.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 11 Jul 2020 12:11:26 +0200
